<?xml version = "1.0"?>
<project name = "Java Project" basedir = "." default = "main">

    <!--Loading properties from build.properties file-->

    <property file = "build.properties"/>

    <!--Setting classpath-->

    <path id = "classpath">
        <fileset dir = "${dependencies.dir}">
            <include name = "*.jar"/>
        </fileset>
        <pathelement path = "${build.dir}"/>
    </path>

    <!--Cleaning dirs that are created on this build-->

    <target name = "clean">
        <delete dir = "${build.dir}"/>
        <echo message = "Deleted ${build.dir}"/>
        
        <delete dir = "${jar.dir}"/>
        <echo message = "Deleted {jar.dir}"/>
        
        <delete dir = "${doc.dir}"/>
        <echo message = "Deleted ${doc.dir}"/>
    </target>

    <!--Creating necessary directories-->

    <target name = "init">
        <mkdir dir = "${build.dir}"/>
        <echo message = "Created ${build.dir}"/>
        
        <mkdir dir = "${jar.dir}"/>
        <echo message = "Created {jar.dir}"/>
        
        <mkdir dir = "${jardependencies.dir}"/>
        <echo message = "Created {jardependencies.dir}"/>

        <mkdir dir = "${doc.dir}"/>
        <echo message = "Created ${doc.dir}"/>
    </target>

    <!--Compiling project-->

    <target name = "compile" depends = "init" description = "Compilation of ${ant.project.name}">
        <javac destdir = "${build.dir}" source = "1.8" target = "1.8">
            <src path = "${src.dir}"/>
            <classpath refid = "classpath"/>
        </javac>
        <copy todir="${build.dir}">
            <fileset dir="Icons">
                <include name="**/*.png"/>
            </fileset>
        </copy>

        <echo message = "Compilation successful."/>
    </target>

    <!--Copying jar dependencies into dist/lib folder-->

    <target name = "cp-dependencies" depends = "init" description = "Copying of necessary dependencies">
        <copy todir = "${jardependencies.dir}">
            <fileset dir = "${dependencies.dir}" includes = "*.jar"/>
        </copy>
    </target>

    <!--Copying log4j.xml into dist folder-->
    
    <target name = "cp-logconfig" depends = "init" description = "Copying of logger configuration.">
        <copy todir = "${jar.dir}">
            <fileset dir = "${src.dir}" includes = "log4j.xml"/>
        </copy>
    </target>

    <target name = "cp-icons" depends = "init" description = "Copying of icons">
        <copy todir = "./Icons">
            <fileset dir = "${src.dir}/Icons" includes = "*.png"/>
        </copy>
    </target>

     <target name = "cp-tips" depends = "init" description = "Copying of tips">
        <copy todir = "${jar.dir}">
            <fileset dir = "." includes = "tips.txt"/>
        </copy>
    </target>

    <target name = "cp-help" depends = "init, generate-doc" description = "Copying of documentation">
        <copy todir = "${jar.dir}/doc">
            <fileset dir = "${doc.dir}" includes = "*/**"/>
        </copy>
    </target>
    

    <!--Creating property holding classpath-->

    <pathconvert property = "classpath.name" pathsep = " ">
        <path refid = "classpath" />
        <mapper>
            <chainedmapper>
                <flattenmapper />
                <globmapper from = "*.jar" to = "lib/*.jar" />
            </chainedmapper>
        </mapper>
    </pathconvert>

    <!--Building executable jar-->

    <target name = "build-jar" depends = "init, compile, cp-dependencies, cp-logconfig, cp-icons, cp-tips" description = "Building executable jar">
        <jar destfile = "${jardestfile}"
            basedir = "."
            includes = "bin/**,Icons/**,src/**,log4j.xml, *.iml">
            <fileset dir = "${build.dir}" includes="**/*.class"/>
            <fileset dir = "${icons.dir}" includes="**/*.png"/>
            <manifest>
                <attribute name = "Main-Class" value = "${mainclass}"/>
                <attribute name = "Class-Path" value = "${classpath.name}"/>
            </manifest>
        </jar>
        <echo message = "Jar creation successful."/>
    </target>

    <!--Generating documentation-->

    <target name = "generate-doc">
        <javadoc sourcepath = "${src.dir}" destdir = "${doc.dir}"
            version = "true" windowtitle = "${ant.project.name}">
            <classpath>
                <fileset dir = "${dependencies.dir}">
                    <include name = "*.jar"/>
                </fileset>
            </classpath>
        </javadoc>
        <echo message = "Documentation has been generated."/>
    </target>

    <!--Default behaviour-->

    <target name = "main" depends = "clean, compile, build-jar, generate-doc, cp-help"/>

</project>